import pygame
import numpy as np

class Champs:
    def __init__ (self, tempature, humidite, tempsAvantMaturation, pos, image):
        self.temperature = tempature
        self.humidite = humidite
        self.TAM = tempsAvantMaturation
        self.pos = np.array(pos)
        self.image = image
        self.imageSize = np.array(self.image.get_size())
        self.rect = pygame.rect.Rect(self.pos, self.image.get_rect().size)
        self.rectScale = self.rect
        self.police = pygame.font.SysFont("Alef", 22) #pygame.font.get_fonts() -> liste des fonts
        self.imgZoom = pygame.transform.scale(self.image, self.imageSize)

    def draw (self, screen, camera):
        scaleImage = camera.scaleImage(self.image)

        if scaleImage: # != None
            self.imgZoom = scaleImage
            self.rectScale = pygame.rect.Rect(camera.convertLocation(self.pos), self.imgZoom.get_size())
        
        screen.blit(self.imgZoom, camera.convertLocation(self.pos))

    def changeText (self, camera):
        scaleText = camera.scaleImage(self.text)
        if scaleText:
            self.zoomText = scaleText

class Houblon (Champs):
    def __init__ (self, pos):
        super().__init__(0, 0, 0, pos, pygame.image.load('../assets/champ.png'))
        self.text = self.police.render("Température : " + str(self.temperature), False, (0,0,0))
        self.zoomText = self.text

    def showInfo (self, screen, camera):
        pygame.draw.rect(screen, (255, 255, 255), pygame.rect.Rect(camera.convertLocation(self.pos), np.array(self.rect.size)*0.75*abs(camera.zoom)))
        self.changeText(camera)

        screen.blit(self.zoomText, camera.convertLocation(self.pos))

class Buisson (Champs):
    def __init__ (self, pos, prix = 10000):
        super().__init__(0, 0, 0, pos, pygame.image.load('../assets/buissonCadenas.png'))
        self.prix = prix
        self.text = self.police.render("Champ disponible à l'achat : " + str(self.prix), False, (0,0,0))
        self.zoomText = self.text

    def showInfo (self, screen, camera):
        pygame.draw.rect(screen, (255, 255, 255), pygame.rect.Rect(camera.convertLocation(self.pos), np.array(self.rect.size)*0.75*abs(camera.zoom)))
        self.changeText(camera)

        screen.blit(self.zoomText, camera.convertLocation(self.pos))

    def buyField (self):
        # Clique sur buisson -> Pop up "Êtes-vous certain ?" -> Oui ? -> Supprime le buisson de la liste et ajoute un Houblon aux mêmes coordonnées
        return Houblon(self.pos)
