import pygame
from Champs import *
import numpy as np
from Camera import *

RAYON_MUR_INVISIBLE = 2000
SAISONS = ["Printemps", "Été", "Automne", "Hiver"]
MOIS = ["Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre"]

class Game:
    def __init__ (self, screen):
        self.screen = screen
        self.screenSize = np.array(self.screen.get_size())
        self.score = 0
        self.money = 10000
        self.displayMoney = 10000
        self.month = 0
        #self.champs = [Houblon((0,0)), Houblon((-200,0)), Houblon((0,-200)), Buisson((400,0)), Buisson((0,400)), Houblon((1000,1000))]#Houblon((100,100)), Houblon((400,100)), Houblon((700,100)), Houblon((100,300)), Houblon((400,300)), Houblon((700,300)), Houblon((100,500)), Houblon((400,500)), Buisson((700,500))]
        self.champs = []
        for i in range(12):
            self.champs.append(Buisson(((i%4)*300-550,(i//4)*200-300)))
        self.clock = pygame.time.Clock()
        self.selectedChamp = None
        self.imageMoney = pygame.image.load("../assets/money.png")
        self.imageMoney = pygame.transform.scale(self.imageMoney, np.array(self.imageMoney.get_size())/3)
        self.police = pygame.font.SysFont("Alef", 30)
        self.camera = Camera(np.array(self.screen.get_size())/2)
        self.background = pygame.image.load('../assets/terre.png')
        self.background = pygame.transform.scale(self.background, (self.screen.get_width(), self.screen.get_height()))
        self.pluie = pygame.image.load('../assets/pluie.png')
        self.pluie = pygame.transform.scale(self.pluie, (200,200))
        self.frame = 0
        self.buyFrame = -1000
        self.grange = pygame.image.load('../assets/grange.webp')
        self.grange = pygame.transform.scale(self.grange, (self.screen.get_width(), self.screen.get_height()))
        self.flecheChangementdroite = pygame.image.load("../assets/flecheScene.png")
        self.flecheChangementgauche = pygame.image.load("../assets/flecheScene2.png")
        self.flecheChangementdroite = pygame.transform.scale(self.flecheChangementdroite, (100,100))
        self.flecheChangementgauche = pygame.transform.scale(self.flecheChangementgauche, (100,100))
        self.coordonnee_image_droite = self.screenSize[0]-self.flecheChangementdroite.get_width() - 10, self.screenSize[1]/2
        self.coordonnee_image_gauche = 10, self.screenSize[1]/2
        self.rectangle_button_fleche = pygame.rect.Rect(*self.coordonnee_image_droite,100,100)
        self.rectangle_button_fleche_gauche = pygame.rect.Rect(*self.coordonnee_image_gauche,100,100)
    
    def gameLoop (self):
        while True:
            self.screen.blit(self.background, (0,0))

            # Météo
            pygame.draw.rect(self.screen, (127, 127, 127), (0, self.screen.get_height() - 200, 200, 200))
            self.screen.blit(self.pluie, (0, self.screen.get_height() - 200))

            # Saison
            surface = self.police.render(SAISONS[self.month%4], False, (0,0,0))
            self.screen.blit(surface, (0, self.screen.get_height() - surface.get_height()))

            isChamp = False
            # Affichage des champs
            for champ in self.champs:
                champ.draw(self.screen, self.camera)

            # Affiche les fps
            fpsText = self.police.render(("%.0f fps" %(self.clock.get_fps())), True, (180,180,180))
            self.screen.blit(fpsText, (self.screen.get_width() - fpsText.get_width(), 0))

            if self.money < self.displayMoney:
                self.displayMoney -= 500 # Si quelque chose coûte moins que 100, changer par -= min(100, self.displayMoney - self.money)
            elif self.money > self.displayMoney:
                self.displayMoney += 500 # Si quelque chose coûte moins que 100, changer par -= min(100, self.money - self.displayMoney)

            textMoney = self.police.render(str(self.displayMoney), True, (255,255,255))
            pygame.draw.rect(self.screen, (0,0,0), (200, self.screen.get_height() - 50, 100, 50))
            self.screen.blit(textMoney, (200, self.screen.get_height()-30))
            self.screen.blit(self.imageMoney, (300, self.screen.get_height()-self.imageMoney.get_height()))
            
            self.screen.blit(self.flecheChangementdroite, self.coordonnee_image_droite)

            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()
                elif event.type == pygame.MOUSEBUTTONDOWN and (*event.pos,0,0) in self.rectangle_button_fleche:
                    self.gameLoopSecondScreen()
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_RIGHT:
                    self.gameLoopSecondScreen()
                elif event.type == pygame.MOUSEMOTION:
                    if event.buttons[2] == 1: #maintenir enfoncé clic droit
                        self.camera.setPosition(np.array(event.rel))

                    for champ in self.champs:
                        if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                            self.selectedChamp = champ
                            isChamp = True
                
                    if not isChamp:
                        self.selectedChamp = None
                
                elif event.type == pygame.MOUSEWHEEL:
                    self.camera.zoomInOut(event.y)

                # Achat d'un champ
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    if event.button == 1:
                        for champ in self.champs:
                            if isinstance(champ, Buisson):
                                if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                                    if self.money >= champ.prix:
                                        self.moneyChange = self.police.render(str(-champ.prix), True, (255,0,0))

                                        self.buyFrame = self.frame
                                    
                                        self.champs.append(champ.buyField())
                                        self.champs.remove(champ)
                                        self.money -= champ.prix
                                    else:
                                        self.moneyError()
                                    

            if self.frame < self.buyFrame + 20:
                self.screen.blit(self.moneyChange, (200, self.screen.get_height()-textMoney.get_height()*4-(self.frame-self.buyFrame)*1.5))

            if self.selectedChamp:
                self.selectedChamp.showInfo(self.screen, self.camera)

            pygame.display.update()
            self.clock.tick(50)
            self.frame += 1

    def moneyError (self):
        loop = True
        while loop:
            popUp = pygame.draw.rect(self.screen, (0,0,0), (self.screenSize/3, self.screenSize/3))

            for event in pygame.event.get(pygame.MOUSEBUTTONDOWN):
                if popUp.contains((*event.pos,0,0)):
                    loop = False
                    break

            pygame.display.update()
            self.clock.tick(50)

    def gameLoopSecondScreen (self):
        while True:
            self.screen.blit(self.grange, (0,0))
            self.screen.blit(self.flecheChangementgauche, self.coordonnee_image_gauche)

            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_LEFT:
                    return
                elif event.type == pygame.MOUSEBUTTONDOWN and (*event.pos,0,0) in self.rectangle_button_fleche_gauche:
                    self.gameLoop()
            pygame.display.update()
            self.clock.tick(50)